       IDENTIFICATION DIVISION.
       PROGRAM-ID.    SIMOCAPE.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2018 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: SIMOCAPE.CBL
      * Copy Files:    PASSPARS.CPY
      *                PASSDUMP.CPY
      *                PASSDATE.CPY
      *                CAPEXCTL.CPY
      * Calls to:      SIMODATE
      *                SIMODUMP
      *                SIMOPARS
      *                User defined program... (optional)
      *****************************************************************
      *
      * SIMOCAPE - is a Callable Application Program Extension that
      * performs a variety of common, reusable functions.
      *
      * CALLING PROTOCOL
      * ----------------
      *    call 'SIMOCAPE' using F01-PARM-LENGTH, F01-PARM-DATA
      *
      *    The first four bytes of the F01-PARM-DATA must be 'STA ',
      *    if not then program will post a message and abend.
      *
      * DESCRIPTION
      * -----------
      * This program will process the JCL parameter from the EXEC
      *
      * //     EXEC  PGM=SIMOCAPE,PARM='STA ID01 additional parameters'
      *
      * This program may also be called by another program.
      *
      *    ************     ************     ************
      *    * SIMOCAPE *--*--* SIMOPARS *-----* Console  *
      *    ************  *  ************     ******dsply*
      *                  *
      *                  *  ************
      *                  *--* SIMODUMP *
      *                  *  ************
      *                  *
      *                  *  ************
      *                  *--* userprog *
      *                  *  ************
      *                  *
      *                  *  ************
      *                  *--* Console  *
      *                     ************
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1997/02/27 Simmons, Created program.
      *
      *****************************************************************
      *
       DATA DIVISION.
       WORKING-STORAGE SECTION.
      *
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *****************************************************************
       01  SIM-TITLE.
           05  T1 pic X(11) value '* SIMOCAPE '.
           05  T2 pic X(34) value 'Application Program Extensions    '.
           05  T3 pic X(10) value ' v03.12.11'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* SIMOCAPE '.
           05  C2 pic X(20) value 'Copyright 1987-2018 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

      *****************************************************************
       01  FIRST-TIME              pic X       value 'Y'.
       01  UPPER-CASE-A            pic X       value 'A'.
       01  UPPER-EBCDIC-STA.
           05  UPPER-EBCDIC-S      pic X       value X'E2'.
           05  UPPER-EBCDIC-T      pic X       value X'E3'.
           05  UPPER-EBCDIC-A      pic X       value X'C1'.
           05  filler              pic X       value X'40'.
       01  UPPER-ASCII-STA.
           05  UPPER-ASCII-S       pic X       value X'53'.
           05  UPPER-ASCII-T       pic X       value X'54'.
           05  UPPER-ASCII-A       pic X       value X'41'.
           05  filler              pic X       value X'20'.

       01  IX-1                    pic 999     value 0.
       01  IX-2                    pic 999     value 0.
       01  IX-3                    pic 999     value 0.
       01  WORK-DATA               pic X(256)  value SPACES.
       01  WORK-N-7                pic 9(7)    value 0.
       01  WORK-08                 pic X(8)    value SPACES.

       01  F01-PARM-LENGTH-COPY    pic 9(5)    value 0.

       01  FLAG-4-COMPILE          pic X       value 'X'.
       01  FLAG-4-PARAMETER        pic X       value 'X'.
       01  FLAG-4-ALPHANUMERIC     pic X       value 'N'.

       01  MSG-AC pic X(32) value 'Compilation is ASCII            '.
       01  MSG-EC pic X(32) value 'Compilation is EBCDIC           '.
       01  MSG-XC pic X(32) value 'Compilation is not ASCII/EBCDIC '.

       01  MSG-AP pic X(32) value 'Parameter is ASCII              '.
       01  MSG-EP pic X(32) value 'Parameter is EBCDIC             '.
       01  MSG-XP pic X(32) value 'Parameter is not ASCII/EBCDIC   '.

       01  MSG-EDIT.
           05  filler           pic X(17) value 'Parameter Number '.
           05  MSG-EDIT-NUMBER  pic 9     value 0.
           05  filler           pic X(3)  value ' - '.
           05  MSG-EDIT-CONTENT pic X(12) value is SPACES.
           05  filler           pic X     value is SPACES.
           05  MSG-EDIT-TEXT    pic X(40) value is SPACES.

      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* SIMOCAPE '.
           05  MESSAGE-TEXT        pic X(68).

      *****************************************************************
      * The following is used by the INSPECT statement to do the
      * conversion from/to UPPER and lower Case.
      *****************************************************************
       01  UPPER-CASE  pic X(26) value 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
       01  LOWER-CASE  pic X(26) value 'abcdefghijklmnopqrstuvwxyz'.
       01  ZERO-NINE   pic X(10) value '0123456789'.

      *****************************************************************
      * The following is used by the INSPECT statement to do the
      * conversion betweeen EBCDIC and ASCII.
      *****************************************************************
       01  EBCDIC-TABLE.
      *>   01                             A B C D E F G H I
      *>   02                             J K L M N O P Q R
      *>   03                             S T U V W X Y Z
      *>   04                             a b c d e f g h i
      *>   05                             j k l m n o p q r
      *>   06                             s t u v w x y z
      *>   07                             0 1 2 3 4 5 6 7 8 9
      *>   08                         space . < ( + | & ! $ * ) ; -
      *>   09  7D/7F Single/Double quote  / , % _ > ? ` : # @7D =7F
      *>   10                             [ ] { } \ ~ ^
           05  filler  pic X(9)  value X'C1C2C3C4C5C6C7C8C9'.
           05  filler  pic X(9)  value X'D1D2D3D4D5D6D7D8D9'.
           05  filler  pic X(8)  value X'E2E3E4E5E6E7E8E9'.
           05  filler  pic X(9)  value X'818283848586878889'.
           05  filler  pic X(9)  value X'919293949596979899'.
           05  filler  pic X(8)  value X'A2A3A4A5A6A7A8A9'.
           05  filler  pic X(10) value X'F0F1F2F3F4F5F6F7F8F9'.
           05  filler  pic X(13) value X'404B4C4D4E4F505A5B5C5D5E60'.
           05  filler  pic X(13) value X'616B6C6D6E6F797A7B7C7D7E7F'.
           05  filler  pic X(7)  value X'ADBDC0D0E0A1B0'.
       01  EBCDIC-INFO redefines EBCDIC-TABLE
                       pic X(95).

      *>   ------------------------------------------------------------
       01  ASCII-TABLE.
      *>   01                             A B C D E F G H I
      *>   02                             J K L M N O P Q R
      *>   03                             S T U V W X Y Z
      *>   04                             a b c d e f g h i
      *>   05                             j k l m n o p q r
      *>   06                             s t u v w x y z
      *>   07                             0 1 2 3 4 5 6 7 8 9
      *>   08                         space . < ( + | & ! $ * ) ; -
      *>   09  27/22 Single/Double quote  / , % _ > ? ` : # @27 =22
      *>   10                             [ ] { } \ ~ ^
           05  filler  pic X(9)  value X'414243444546474849'.
           05  filler  pic X(9)  value X'4A4B4C4D4E4F505152'.
           05  filler  pic X(8)  value X'535455565758595A'.
           05  filler  pic X(9)  value X'616263646566676869'.
           05  filler  pic X(9)  value X'6A6B6C6D6E6F707172'.
           05  filler  pic X(8)  value X'737475767778797A'.
           05  filler  pic X(10) value X'30313233343536373839'.
           05  filler  pic X(13) value X'202E3C282B7C2621242A293B2D'.
           05  filler  pic X(13) value X'2F2C255F3E3F793A2340273D22'.
           05  filler  pic X(7)  value X'5B5D7B7D5C7E5E'.
       01  ASCII-INFO  redefines ASCII-TABLE
                       pic X(95).

       01  STD-DEBUG-FUNCTION          pic X(8)  value SPACES.
       01  STD-IDENTIFIER              pic X(4)  value SPACES.
       01  STD-USER-FUNCTION           pic X(8)  value SPACES.
       01  FMTC2-DATE-FUNCTION         pic X(10) value SPACES.
       01  STD-AMOUNT                  pic X(11) value SPACES.
       01  FMTC2-ALPHANUMERIC-FUNCTION pic X(8)  value SPACES.

      *****************************************************************
      *>    The copy file of the pass area for calling SIMOPARS, the
      *>    parameter parsing routine.
       COPY PASSPARS.
      *>    -----------------------------------------------------------
      *>    The copy file of the pass area for calling SIMODUMP, the
      *>    hexadecimal dump routine.
       COPY PASSDUMP.
      *>    -----------------------------------------------------------
      *>    The copy file of the pass area for calling SIMODATE, the
      *>    date editing routine.
       COPY PASSDATE.
      *>    -----------------------------------------------------------
      *>    The copy file of the pass area for calling a user-program.
       COPY PASSCAPE.

      *****************************************************************
       LINKAGE SECTION.
       01  F01-PARM-BUFFER.
           05  F01-PARM-LENGTH     pic S9(4)   comp.
           05  F01-PARM-DATA       pic X(256).

      *****************************************************************
      * Mainline processing routine...
      *****************************************************************
       PROCEDURE DIVISION using F01-PARM-BUFFER.
           if  FIRST-TIME not = 'N'
               if  STD-DEBUG-INFO = 'DEBUG   '
               or  STD-DEBUG-INFO = 'TRACE   '
                   perform POST-COPYRIGHT
               end-if
               perform ASCII-OR-EBCDIC-COMPILATION
               move 'N' to FIRST-TIME
           end-if

           perform ASCII-OR-EBCDIC-PARAMETER
           move F01-PARM-DATA to WORK-DATA
           if  FLAG-4-PARAMETER not = FLAG-4-COMPILE
               if  FLAG-4-COMPILE = 'A'
                   inspect WORK-DATA
                   converting EBCDIC-INFO to ASCII-INFO
               else
                   inspect WORK-DATA
                   converting ASCII-INFO to EBCDIC-INFO
               end-if
           end-if

           perform MOVE-AND-CONVERT-TO-UPPER-CASE
           perform DISPLAY-THE-PARAMETER-INFO
           perform PARSE-THE-PARAMETER-DATA
           perform DISPLAY-THE-PARAMETER-KEYWORDS
           perform EDIT-AND-FORMAT-PARAMETERS

           if  STD-DEBUG-FUNCTION = 'DEBUG   '
           or  STD-DEBUG-FUNCTION = 'DUMP    '
               perform HEX-DUMP-OF-PARSING-BUFFER
               perform SIMODUMP-TO-ASCII-OR-EBCDIC
               perform DUMP-SIMOTIME-BUFFER
           end-if

           evaluate FMTC2-ALPHANUMERIC-FUNCTION
               when 'CALL    ' perform CLOSE-WITH-CALL
               when 'TEST    ' perform CLOSE-WITH-DISPLAY
           end-evaluate

           GOBACK.

      *****************************************************************
      * The following routines are in alphabetical order...           *
      *****************************************************************

      *****************************************************************
      * Determine the compilation environment for this program by
      * the working storage item. If the UPPER-CASE-A field is a
      * x'41' then program is ASCI. If the field is x'C1' then the
      * program is EBCDIC.
      *****************************************************************
       ASCII-OR-EBCDIC-COMPILATION.
           evaluate UPPER-CASE-A
               when UPPER-EBCDIC-A move MSG-EC to MESSAGE-TEXT
                                   move 'E'    to FLAG-4-COMPILE
               when UPPER-ASCII-A  move MSG-AC to MESSAGE-TEXT
                                   move 'A'    to FLAG-4-COMPILE
               when OTHER          move MSG-XC to MESSAGE-TEXT
           end-evaluate
           perform POST-CONDITIONAL-TRACE

      *>   If environment cannot be recognized as ASCII or EBCDIC
      *>   then stop the program.
           if  FLAG-4-COMPILE = 'X'
               perform POST-ABEND
               STOP RUN
           end-if
           exit.

      *****************************************************************
      * Determine if the Parameter is ASCII or EBCDIC by the format of
      * the first keyword in the parameter string that should be "STA".
      *****************************************************************
       ASCII-OR-EBCDIC-PARAMETER.
           evaluate F01-PARM-DATA(1:4)
               when UPPER-EBCDIC-STA   move 'E' to FLAG-4-PARAMETER
                                       move MSG-EP to MESSAGE-TEXT
               when UPPER-ASCII-STA    move 'A' to FLAG-4-PARAMETER
                                       move MSG-AP to MESSAGE-TEXT
               when OTHER              move 'X' to FLAG-4-PARAMETER
                                       move MSG-XP to MESSAGE-TEXT
           end-evaluate
           perform POST-CONDITIONAL-TRACE
      *>   If parameter cannot be recognized as ASCII or EBCDIC
      *>   then stop the program.
           if  FLAG-4-PARAMETER = 'X'
               perform POST-ABEND
               STOP RUN
           end-if

           exit.

       CLOSE-WITH-CALL.
           move STD-GREGORIAN-DATE   to CAPE-GREGORIAN-DATE
           move STD-DATE-EDITED      to CAPE-DATE-EDITED
           move STD-DATE-VERBAGE     to CAPE-DATE-VERBAGE
           move STD-JULIAN-DATE      to CAPE-JULIAN-DATE
           move STD-DAYS-REMAINING   to CAPE-DAYS-REMAINING
           move STD-LEAP-YEAR-YN     to CAPE-LEAP-YEAR-YN
           move STD-MM-DAYS          to CAPE-DAYS-IN-MONTH
           move STD-MONTH-VERBAGE    to CAPE-MONTH-VERBAGE
           move STD-AMOUNT           to CAPE-AMOUNT

           call STD-USER-FUNCTION using CAPE-XCTL-API
           exit.

       CLOSE-WITH-DISPLAY.
           move 'Processing the TEST request   ' to MESSAGE-TEXT
           perform POST-MESSAGE

           move 'Gregorian Date .............. ' to MESSAGE-TEXT
           move STD-GREGORIAN-DATE               to MESSAGE-TEXT(31:10)
           perform POST-MESSAGE

           move 'Edited Gregorian Date ....... ' to MESSAGE-TEXT
           move STD-DATE-EDITED                  to MESSAGE-TEXT(31:10)
           perform POST-MESSAGE

           move 'Text for the Date............ ' to MESSAGE-TEXT
           move STD-DATE-VERBAGE                 to MESSAGE-TEXT(31:16)
           perform POST-MESSAGE

           move 'Julian Date ................. ' to MESSAGE-TEXT
           move STD-JULIAN-DATE                  to MESSAGE-TEXT(31:7)
           perform POST-MESSAGE

           move 'Days Remaining in the Year... ' to MESSAGE-TEXT
           move STD-DAYS-REMAINING               to MESSAGE-TEXT(31:3)
           perform POST-MESSAGE

           move 'Leap Year Flag (Y or N) ..... ' to MESSAGE-TEXT
           move STD-LEAP-YEAR-YN                 to MESSAGE-TEXT(31:1)
           perform POST-MESSAGE

           move 'Days in the Month ........... ' to MESSAGE-TEXT
           move STD-MM-DAYS                      to MESSAGE-TEXT(31:2)
           perform POST-MESSAGE

           move 'Text for the Month .......... ' to MESSAGE-TEXT
           move STD-MONTH-VERBAGE                to MESSAGE-TEXT(31:10)
           perform POST-MESSAGE

           move 'Amount ...................... ' to MESSAGE-TEXT
           move STD-AMOUNT                       to MESSAGE-TEXT(31:11)
           perform POST-MESSAGE

           exit.

      *****************************************************************
      * Display the length and the original parameter plus the copied
      * parameter that has been converted to upper case...
      *****************************************************************
       DISPLAY-THE-PARAMETER-INFO.
           if  F01-PARM-LENGTH < 1
               move 'Parameter length is 00000'   to MESSAGE-TEXT
               perform POST-CONDITIONAL-TRACE
           else
               move 'Parameter length is ?????'   to MESSAGE-TEXT
               move F01-PARM-LENGTH-COPY          to MESSAGE-TEXT(21:5)
               perform POST-CONDITIONAL-TRACE
               move WORK-DATA(1:F01-PARM-LENGTH)  to MESSAGE-TEXT
               perform POST-CONDITIONAL-TRACE
               move PRS-BUFFER(1:F01-PARM-LENGTH) to MESSAGE-TEXT
               perform POST-CONDITIONAL-TRACE
           end-if
           exit.

      *****************************************************************
      * Display the contents of the parsing tables.
      *****************************************************************
       DISPLAY-THE-PARAMETER-KEYWORDS.
           add 1 to ZERO giving IX-1
           perform
               until PRS-SIZE(IX-1) = 0
               or    PRS-POSITION(IX-1) = 0
               or    IX-1             > PRS-TABLE-MAX
               perform POST-TABLE-ITEM
               add 1 to IX-1
           end-perform
           exit.

      *****************************************************************
       DUMP-BUFFER.
           move 'DUMP'         to SIMODUMP-REQUEST
           move 'OUT1'         to SIMODUMP-OUTPUT
           add 128 to ZERO giving SIMODUMP-LENGTH
           call 'SIMODUMP'  using SIMODUMP-PASS-AREA
                                  SIMODUMP-BUFFER
           exit.

      *****************************************************************
       DUMP-SIMOTIME-BUFFER.
      *>   ------------------------------------------------------------
      *>   Display the contents of the parsing buffer in DUMP format.
           move 'HEXDUMP2' to SIMODUMP-DUMP-ID
           perform DUMP-BUFFER
           exit.

      *****************************************************************
       EDIT-AND-FORMAT-PARAMETERS.
           add 2 to ZERO giving IX-1
           perform
               until PRS-SIZE(IX-1) = 0
               or    PRS-POSITION(IX-1) = 0
               or    IX-1             > PRS-TABLE-MAX
               evaluate IX-1
                   when 2 perform EDIT-DEBUG-FUNCTIONS
                   when 3 perform EDIT-IDENTIFIER
                   when 4 perform EDIT-USER-FUNCTION
                   when 5 perform EDIT-DATE-FUNCTION
                   when 6 perform EDIT-AMOUNT-FUNCTION
                   when 7 perform EDIT-ALPHANUMERIC-FUNCTION
               end-evaluate
               add 1 to IX-1
           end-perform
           exit.

       EDIT-ALPHANUMERIC-FUNCTION.
           move SPACES to FMTC2-ALPHANUMERIC-FUNCTION
           if  PRS-SIZE(IX-1) < 9
           and PRS-SIZE(IX-1) > 0
               move PRS-BUFFER(PRS-POSITION(IX-1):PRS-SIZE(IX-1))
               to   FMTC2-ALPHANUMERIC-FUNCTION
           end-if
      *>   Prepare information for display to console...
           add IX-1 to ZERO giving MSG-EDIT-NUMBER
           move SPACES to MSG-EDIT-CONTENT
           move FMTC2-ALPHANUMERIC-FUNCTION to MSG-EDIT-CONTENT
      *>   Prepare a work field for determining allowable content...
           move FMTC2-ALPHANUMERIC-FUNCTION to WORK-08
      *>   The following statement will not allow spaces as
      *>   valid characters...
           inspect WORK-08(1:PRS-SIZE(IX-1))
                   replacing all SPACE by '/'
           perform EDIT-ALPHABET-OR-NUMBERS

           if  FLAG-4-ALPHANUMERIC = 'Y'
               move 'Contains only ALPHA and NUMERIC.' to MSG-EDIT-TEXT
               move MSG-EDIT to MESSAGE-TEXT
               perform POST-CONDITIONAL-TRACE
           else
               move 'Contains non-ALPHANUMERIC.' to MSG-EDIT-TEXT
               move MSG-EDIT to MESSAGE-TEXT
               perform POST-CONDITIONAL-TRACE
           end-if

           exit.

       EDIT-ALPHABET-OR-NUMBERS.
           inspect WORK-08 converting UPPER-CASE  to SPACES
           inspect WORK-08 converting LOWER-CASE  to SPACES
           inspect WORK-08 converting ZERO-NINE   to SPACES
           if  WORK-08 = SPACES
               move 'Y' to FLAG-4-ALPHANUMERIC
           else
               move 'N' to FLAG-4-ALPHANUMERIC
           end-if
           exit.

      *----------------------------------------------------------------
       EDIT-IDENTIFIER.
           move SPACES to STD-IDENTIFIER
           if  PRS-SIZE(IX-1) = 4
               move PRS-BUFFER(PRS-POSITION(IX-1):PRS-SIZE(IX-1))
                 to STD-IDENTIFIER
           end-if

           add IX-1 to ZERO giving MSG-EDIT-NUMBER
           move SPACES to MSG-EDIT-CONTENT
           move PRS-BUFFER(PRS-POSITION(IX-1):PRS-SIZE(IX-1))
             to MSG-EDIT-CONTENT
           if  STD-IDENTIFIER = 'ID01'
           or  STD-IDENTIFIER = 'ID02'
               move 'AOK for Identifier...' to MSG-EDIT-TEXT
               move MSG-EDIT to MESSAGE-TEXT
               perform POST-CONDITIONAL-TRACE
           else
               move 'NOK for Identifier...' to MSG-EDIT-TEXT
               move MSG-EDIT to MESSAGE-TEXT
               perform POST-ABEND
           end-if
           exit.

      *----------------------------------------------------------------
       EDIT-DEBUG-FUNCTIONS.
           move SPACES to STD-DEBUG-FUNCTION
           if  PRS-SIZE(IX-1) < 9
           and PRS-SIZE(IX-1) > 0
               move PRS-BUFFER(PRS-POSITION(IX-1):PRS-SIZE(IX-1))
                 to STD-DEBUG-FUNCTION
           end-if

           add IX-1 to ZERO giving MSG-EDIT-NUMBER
           move SPACES to MSG-EDIT-CONTENT
           move PRS-BUFFER(PRS-POSITION(IX-1):PRS-SIZE(IX-1))
             to MSG-EDIT-CONTENT
           if  STD-DEBUG-FUNCTION = 'DUMP    '
           or  STD-DEBUG-FUNCTION = 'TRACE   '
           or  STD-DEBUG-FUNCTION = 'DEBUG   '
           or  STD-DEBUG-FUNCTION = 'NODEBUG '
               move STD-DEBUG-FUNCTION to STD-DEBUG-INFO
               move 'AOK for Debug Function...' to MSG-EDIT-TEXT
               move MSG-EDIT to MESSAGE-TEXT
               perform POST-CONDITIONAL-TRACE
           else
               move 'NOK for Debug Function...' to MSG-EDIT-TEXT
               move MSG-EDIT to MESSAGE-TEXT
               perform POST-ABEND
           end-if
           exit.

      *----------------------------------------------------------------
       EDIT-USER-FUNCTION.
           move SPACES to STD-USER-FUNCTION
           if  PRS-SIZE(IX-1) < 9
           and PRS-SIZE(IX-1) > 0
               move PRS-BUFFER(PRS-POSITION(IX-1):PRS-SIZE(IX-1))
                 to STD-USER-FUNCTION
           end-if

           add IX-1 to ZERO giving MSG-EDIT-NUMBER
           move SPACES to MSG-EDIT-CONTENT
           move PRS-BUFFER(PRS-POSITION(IX-1):PRS-SIZE(IX-1))
             to MSG-EDIT-CONTENT
           if  STD-USER-FUNCTION = 'STAFMTC2'
           or  STD-USER-FUNCTION = 'STAFMTC3'
               move 'AOK for User Function...' to MSG-EDIT-TEXT
               move MSG-EDIT to MESSAGE-TEXT
               perform POST-CONDITIONAL-TRACE
           else
               move 'NOK for User Function...' to MSG-EDIT-TEXT
               move MSG-EDIT to MESSAGE-TEXT
               perform POST-ABEND
           end-if

           exit.

      *----------------------------------------------------------------
      *>   This routine will accept dates in the following formats
      *>     ccyymmdd
      *>     ccyy/mm/dd
      *>     ccyy-mm-dd
      *>     ccyy.mm.dd
      *----------------------------------------------------------------
       EDIT-DATE-FUNCTION.

           add IX-1 to ZERO giving MSG-EDIT-NUMBER
           move SPACES to MSG-EDIT-CONTENT
           move PRS-BUFFER(PRS-POSITION(IX-1):PRS-SIZE(IX-1))
             to MSG-EDIT-CONTENT
           move 'WIP for Calling SIMODATE...' to MSG-EDIT-TEXT
           move MSG-EDIT to MESSAGE-TEXT
           perform POST-CONDITIONAL-TRACE

           move SPACES to STD-GREGORIAN-4-EDIT
           if  PRS-SIZE(IX-1) < 11
           or  PRS-SIZE(IX-1) > 7
               move 'EDITDATE'           to STD-REQUEST
               move '-'                  to STD-DATE-EDIT-BYTE
               move PRS-BUFFER(PRS-POSITION(IX-1):PRS-SIZE(IX-1))
                 to STD-GREGORIAN-4-EDIT
               call 'SIMODATE' using STD-SIMODATE
           else
               move 'NOK for Date Value, field length is incorrect...'
                 to MSG-EDIT-TEXT
               move MSG-EDIT to MESSAGE-TEXT
               perform POST-ABEND
           end-if

           exit.

      *----------------------------------------------------------------
       EDIT-AMOUNT-FUNCTION.
           move SPACES to STD-AMOUNT
           add IX-1 to ZERO giving MSG-EDIT-NUMBER
           if  PRS-SIZE(IX-1) < 9
           and PRS-SIZE(IX-1) > 0
               move PRS-BUFFER(PRS-POSITION(IX-1):PRS-SIZE(IX-1))
                 to STD-AMOUNT
           end-if
      *>   Right Adjust...
           perform until STD-AMOUNT(11:1) not = SPACE
               add 10 to ZERO giving IX-2
               perform 10 times
                   move STD-AMOUNT(IX-2:1)
                     to STD-AMOUNT(IX-2 + 1:1)
                   subtract 1 from IX-2
               end-perform
               move ZERO to STD-AMOUNT(1:1)
           end-perform
      *>   Remove decimal...
           if STD-AMOUNT(9:1) = '.'
              add 8 to ZERO giving IX-2
              perform 8 times
                  move STD-AMOUNT(IX-2:1)
                    to STD-AMOUNT(IX-2 + 1:1)
                  subtract 1 from IX-2
              end-perform
           end-if

           if  STD-AMOUNT is NUMERIC
               move STD-AMOUNT to MSG-EDIT-CONTENT
               move 'AOK for Amount Function...' to MSG-EDIT-TEXT
               move MSG-EDIT to MESSAGE-TEXT
               perform POST-CONDITIONAL-TRACE
           else
               move STD-AMOUNT to MSG-EDIT-CONTENT
               move 'NOK for Amount Function...' to MSG-EDIT-TEXT
               move MSG-EDIT to MESSAGE-TEXT
               perform POST-ABEND
           end-if

           exit.

      *----------------------------------------------------------------
       EDIT-CLOSE-FUNCTION.

           exit.

      *****************************************************************
       HEX-DUMP-OF-PARSING-BUFFER.
      *>   ------------------------------------------------------------
      *>   Display the contents of the parsing buffer in DUMP format.
           move PRS-BUFFER      to SIMODUMP-BUFFER
           move 'HEXDUMP1'      to SIMODUMP-DUMP-ID
           perform DUMP-BUFFER
           exit.

      *****************************************************************
       MOVE-AND-CONVERT-TO-UPPER-CASE.
      *>   ------------------------------------------------------------
      *>   Move Parameter Length value to a move/display field...
           add F01-PARM-LENGTH to ZERO giving F01-PARM-LENGTH-COPY
      *>   ------------------------------------------------------------
      *>   Move Parameter data to the parsing buffer
           move SPACES    to PRS-BUFFER
           move WORK-DATA(1:F01-PARM-LENGTH)
           to   PRS-BUFFER(1:F01-PARM-LENGTH)
      *>   ------------------------------------------------------------
      *>   Convert parsing buffer to upper case...
           inspect PRS-BUFFER converting LOWER-CASE to UPPER-CASE
           exit.

      *****************************************************************
       PARSE-THE-PARAMETER-DATA.
      *>   ------------------------------------------------------------
      *>   Display the start of task message.
           move 'Start Parse for Sample-Task...' to MESSAGE-TEXT
           perform POST-CONDITIONAL-TRACE
      *>   ------------------------------------------------------------
      *>   Prepare control items for parsing.
           move '0' to PRS-REQUEST
           add 9    to ZERO giving PRS-STATUS
           move ' ' to PRS-DELIMITER
      *    move 'N' to PRS-TERMINATOR-FLAG
           move ' ' to PRS-TERMINATOR-BYTE
           add 32   to ZERO giving PRS-TABLE-MAX
           add 128  to ZERO giving PRS-BUFFER-SIZE
      *>   ------------------------------------------------------------
      *>   Move the data string to the parsing buffer and call
      *>   the parsing routine.
           call 'SIMOPARS'   using PRS-PARAMETERS
           exit.

      *****************************************************************
       POST-TABLE-ITEM.
           move 'Item-nnnn, Offset-nnnn, Length-nnnn, Parameter - '
             to MESSAGE-TEXT(1:49)
           move IX-1 to MESSAGE-TEXT(6:4)
           move PRS-POSITION(IX-1) to MESSAGE-TEXT(19:4)
           move PRS-SIZE(IX-1) to MESSAGE-TEXT(32:4)
           if  PRS-SIZE(IX-1) < 20
               move PRS-BUFFER(PRS-POSITION(IX-1):PRS-SIZE(IX-1))
                 to MESSAGE-TEXT(50:PRS-SIZE(IX-1))
           else
               move PRS-BUFFER(PRS-POSITION(IX-1):19)
                 to MESSAGE-TEXT(50:19)
           end-if
           perform POST-CONDITIONAL-TRACE
           exit.

      *****************************************************************
      *    Display Copyright or Program Message...
      *    ------------------------------------------------------------
       POST-ABEND.
           if  MESSAGE-TEXT not = SPACES
               perform POST-MESSAGE
           end-if
           move 'Program is ABENDING...' to MESSAGE-TEXT
           perform POST-CONSOLE
           perform POST-MESSAGE
           STOP RUN.

       POST-CONDITIONAL-TRACE.
           if  STD-DEBUG-INFO = 'DEBUG   '
           or  STD-DEBUG-INFO = 'TRACE   '
               display MESSAGE-BUFFER
           end-if
           move SPACES to MESSAGE-TEXT
           exit.

       POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.

       POST-CONSOLE.
           display MESSAGE-BUFFER upon console
           exit.

       POST-MESSAGE.
           display MESSAGE-BUFFER
           move SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       SIMODUMP-TO-ASCII-OR-EBCDIC.
      *>   ------------------------------------------------------------
      *>   Convert between EBCDIC and ASCII based on the current
      *>   ASCII or EBCDIC environment.
      *>   Display the contents of the parsing tables.
           if  FLAG-4-COMPILE = 'E'
               inspect SIMODUMP-BUFFER converting EBCDIC-INFO
                                               to ASCII-INFO
           else
               inspect SIMODUMP-BUFFER converting ASCII-INFO
                                               to EBCDIC-INFO
           end-if
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
