       IDENTIFICATION DIVISION.
       PROGRAM-ID.    STAFMTC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: STAFMTC1.CBL
      * Calls to:      SIMOCAPE
      *****************************************************************
      *
      * STAFMTC1 - Demonstration of Passing, Parsing and Converting
      *            data string between JCL and COBOL.
      *
      * CALLING PROTOCOL
      * ----------------
      * Use standard procedure to RUN or ANIMATE.
      *
      * DESCRIPTION
      * -----------
      * This program calls the Callable Application Progam Extension
      * (i.e. SimoCAPE) to edit a data string and then pass an edited
      * and formatted data string to a user-defined program. SimoCAPE
      * also calls the SimoDATE routine to edit and format date
      * information.
      *
      * ************
      * * STAFMTJ1 *
      * ********jcl*
      *      *
      *      *
      *      *
      * ************     ************     ************
      * * SIMOCAPE *--*--* SIMOPARS *-----* Console  *
      * ************  *  ************     ******dsply*
      *      *        *
      *      *        *  ************
      *      *        *--* SIMODUMP *
      *      *        *  ************
      *      *        *
      *      *        *  ************
      *      *        *--* userprog *
      *      *        *  ************
      *      *        *
      *      *        *  ************
      *      *        *--* Console  *
      *      *           ************
      *      *
      *      *
      * ************     ************     ************     ************
      * * STAFMTC1 *-----* SIMOCAPE *--*--* SIMOPARS *-----* Console  *
      * ********cbl*     ************  *  ************     ******dsply*
      *      *                         *
      *      *                         *  ************
      *      *                         *--* SIMODUMP *
      *      *                         *  ************
      *      *                         *
      *      *                         *  ************
      *      *                         *--* userprog *
      *      *                         *  ************
      *      *                         *
      *      *                         *  ************
      *      *                         *--* Console  *
      *      *                            ************
      * ************
      * *   EOJ    *
      * ************
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1997/02/27 Simmons, Created program.
      * 1997/02/27 Simmons, No changes to date.
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.
       DATA DIVISION.

       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* STAFMTC1 '.
           05  T2 pic X(34) value 'Parse & Process Parameter Strings '.
           05  T3 pic X(10) value ' v03.01.24'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* STAFMTC1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* STAFMTC1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* STAFMTC1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

      *****************************************************************
       01  F01-PARM-BUFFER.
           05  F01-PARM-LENGTH     pic S9(4)   comp.
           05  F01-PARM-DATA       pic X(256).

      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* STAFMTC1 '.
           05  MESSAGE-TEXT        pic X(68)   value is SPACES.

      *****************************************************************
       PROCEDURE DIVISION.
           perform POST-COPYRIGHT

           perform APPLICATION-TASK-01
           perform APPLICATION-TASK-02
           perform APPLICATION-TASK-03
           perform APPLICATION-TASK-04
           perform APPLICATION-TASK-05

           move 'Program is complete...' to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           perform THANK-YOU.

           GOBACK.

      *****************************************************************
       APPLICATION-TASK-01.
           move 'Task-01 is starting, NODEBUG Test' to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           move 'STA NOdebug ID02 stafmtc3 2001/3/3 22.95 call'
             to F01-PARM-DATA
           move F01-PARM-DATA to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           add length of F01-PARM-DATA to ZERO giving F01-PARM-LENGTH

           call 'SIMOCAPE' using F01-PARM-LENGTH, F01-PARM-DATA

           move 'Task-01 is complete, NODEBUG Test' to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE
           exit.

      *****************************************************************
       APPLICATION-TASK-02.
           move 'Task-02 is starting, DUMP Test' to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           move 'STA Dump ID02 stafmtc2 2000/07/4 9.49 stop-001'
             to F01-PARM-DATA
           move F01-PARM-DATA to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           add length of F01-PARM-DATA to ZERO giving F01-PARM-LENGTH

           call 'SIMOCAPE' using F01-PARM-LENGTH, F01-PARM-DATA

           move 'Task-02 is complete, DUMP Test' to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           exit.

      *****************************************************************
       APPLICATION-TASK-03.
           move 'Task-03 is starting, DEBUG Test' to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           move 'STA debug ID02 stafmtc3 1996/07/4 10.00 //Finish'
             to F01-PARM-DATA
           move F01-PARM-DATA to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           add length of F01-PARM-DATA to ZERO giving F01-PARM-LENGTH

           call 'SIMOCAPE' using F01-PARM-LENGTH, F01-PARM-DATA

           move 'Task-03 is complete, DEBUG Test' to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           exit.

      *****************************************************************
       APPLICATION-TASK-04.
           move 'Task-04 is starting, NODEBUG Test' to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           move 'STA NODEBUG ID02 stafmtc2 1943/05/22 10.00 c9a2x6m1'
             to F01-PARM-DATA
           move F01-PARM-DATA to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           add length of F01-PARM-DATA to ZERO giving F01-PARM-LENGTH

           call 'SIMOCAPE' using F01-PARM-LENGTH, F01-PARM-DATA

           move 'Task-04 is complete, NODEBUG Test' to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           exit.

      *****************************************************************
       APPLICATION-TASK-05.
           move 'Task-05 is starting, NODEBUG Test' to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           move 'STA NODEBUG ID02 stafmtc2 1944/4/1 99.98 CALL'
             to F01-PARM-DATA
           move F01-PARM-DATA to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           add length of F01-PARM-DATA to ZERO giving F01-PARM-LENGTH

           call 'SIMOCAPE' using F01-PARM-LENGTH, F01-PARM-DATA

           move 'Task-05 is complete, NODEBUG Test' to MESSAGE-TEXT
           perform DISPLAY-CONSOLE-MESSAGE

           exit.

      *****************************************************************
       DISPLAY-CONSOLE-MESSAGE.
           display MESSAGE-BUFFER
           move SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       ABEND-MESSAGE.
           if  MESSAGE-TEXT not = SPACES
               perform DISPLAY-CONSOLE-MESSAGE
           else
               move '* STAFMTC1 is ABENDING...'  to MESSAGE-TEXT
               perform DISPLAY-CONSOLE-MESSAGE
           end-if
           exit.

      *****************************************************************
       POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.

      *****************************************************************
       THANK-YOU.
           display SIM-THANKS-01
           display SIM-THANKS-02
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
